#include <stdio.h>
#include "cuda.h"
#include "cuda_runtime_api.h"
#include <assert.h>
#define N 2 //16

__device__ int bar(int x) {

	return x + 1;
}

__global__ void* foo(int *A) {

	A[threadIdx.x] = bar(threadIdx.x);
}


int main () {

	int *a;
	int *dev_a;
	int size = N*sizeof(int);

	cudaMalloc((void**)&dev_a, size);

	a = (int*)malloc(size);

	for (int i = 0; i < N; i++)
		a[i] = rand() %10+1;

	printf("a:  ");
	for (int i = 0; i < N; i++)
		printf("%d	", a[i]);

	//foo<<<1,N>>>(dev_a);
	verify_kernel(foo, 1, N, dev_a);

	cudaMemcpy(a,dev_a,size,cudaMemcpyDeviceToHost);

	printf("\nResultado de a:\n   ");

	for (int i = 0; i < N; i++){
		printf("%d	", a[i]);
		assert(a[i]== (i+1));
	}

	free(a);
	cudaFree(dev_a);

	return 0;
}
