#include <stdio.h>
#include <stdlib.h>
#include "cuda.h"
#include "cuda_runtime_api.h"
#include <assert.h>

#define N 4//64

__global__ void foo(float* A) {

  if(blockIdx.x == 0)
	  A[threadIdx.x] = 50.f;
}

int main() {
	float *a = 0;
	float *dev_a;

	a = (float*)malloc(N*sizeof(float));

	cudaMalloc((void**)&dev_a, N*sizeof(float));

	cudaMemcpy(dev_a, a, N*sizeof(float), cudaMemcpyHostToDevice);

		//foo<<<N, 1>>>(dev_a);
		verify_kernel_f(foo, N, 1, dev_a);

	cudaMemcpy(a, dev_a, N*sizeof(float), cudaMemcpyDeviceToHost);

	printf ("%.1f", *a);

		assert(*a == 50.0);

	free(a);
	cudaFree(dev_a);

	return 0;
}
