//xfail:BOOGIE_ERROR
//--blockDim=512 --gridDim=64 --loop-unwind=2 --no-inline
//kernel.cu: error: possible write-write race on B
#include <cuda.h>
#include <cuda_runtime_api.h>
#include <stdio.h>
#include <assert.h>
#define N 512


extern "C" {

__global__ void helloCUDA(float *A)
{
    __shared__ float B[256];

    for(int i = 0; i < 10; i ++) {
        B[i] = A[i];
    }
}

}

int main() {

	float *A;
	float *dev_A;

	float size= N*sizeof(float);

	A=(float*)malloc(size);

	cudaMalloc((void**)&dev_A, size);

	for (int i = 0; i < N; i++){
		A[i] = rand() %10+1;
		printf("%.1f; ", A[i]);
	}

	printf("\n");

	cudaMemcpy(dev_A, A, size, cudaMemcpyHostToDevice);
	
//		helloCUDA<<<64,N>>>(dev_A);
	verify_kernel(helloCUDA, 64, N, dev_A);

	cudaMemcpy(A, dev_A, size, cudaMemcpyDeviceToHost);

	cudaFree(dev_A);
	free(A);

}

