//gpuverify --blockDim=4 --gridDim=1 kernel.cu
//pass: checka se o argumento do tipo ponteiro pra função é passado com sucesso

__device__ float multiplyByTwo(float *v, unsigned int tid) {

    return v[tid] * 2.0f;
}

__device__ float divideByTwo(float *v, unsigned int tid) {

    return v[tid] * 0.5f;
}

typedef float(*funcType)(float*, unsigned int);

__global__ void foo(float *v, funcType* f, unsigned int size)
{

	 __requires(*f = multiplyByTwo);

	__assert(*f == divideByTwo || *f == multiplybyTwo);

	unsigned int tid = blockIdx.x * blockDim.x + threadIdx.x;

    if (tid < size) {
        v[tid] = (*f)(v, tid);
    }
}
