//gpuverify --blockDim=4 --gridDim=1 kernel.cu
//fail: assertion
//--blockDim=1024 --gridDim=1 --no-inline
/*
#include <stdio.h>
#include <cuda.h>
#include "cuda_runtime_api.h"
#include <assert.h>
#define N 4//1024
*/
typedef float(*funcType)(float*, unsigned int);

__device__ float multiplyByTwo(float *v, unsigned int tid)
{
    return v[tid] * 2.0f;
}

__device__ float divideByTwo(float *v, unsigned int tid)
{
    return v[tid] * 0.5f;
}

__device__ funcType grabFunction(int i) {

  if (i == 0)
    return multiplyByTwo;
  else
    return divideByTwo;
}

__global__ void foo(float *v, unsigned int size, int i)
{

    unsigned int tid = blockIdx.x * blockDim.x + threadIdx.x;
    funcType f = grabFunction(i);

	assert(*f == multiplyByTwo || *f == divideByTwo);

    if (tid < size)
    {
    	float x = (*f)(v, tid);
		x += multiplyByTwo(v, tid);
		v[threadIdx.x] = x;
    }
}
